import os

bins = sorted(os.listdir("src_bin"))
mods = os.listdir("mod_bin")

count = 1
binlist = []
modca = []
modld = []

modloc = {
    "00_07":0xF000,
    "01_07":0xF000,
    "02_00":0x8000,
    "02_01":0x9000,
    "02_12":0xF000,
    "03_00":0x8000,
    "03_07":0xF000,
    "04_07":0xF000,
    "05_00":0x8000,
    "05_01":0x9000,
    "05_0E":0xF000,
    "06_00":0x8000,
    "06_01":0x9000,
    "06_10":0xF000,
    "07_07":0xF000,
    "08_00":0x8000,
    "08_01":0x9000,
    "08_1B":0xF000,
    "09_00":0x8000,
    "09_01":0x9000,
    "09_0D":0xF000,
    "0A_07":0xF000,
    "0B_00":0x8000,
    "0B_01":0x9000,
    "0B_0E":0xF000,
    "0C_07":0xF000,
    "0D_00":0x8000,
    "0D_01":0x9000,
    "0D_0D":0xF000,
    "0E_00":0x8000,
    "0E_07":0xF000,
    "0F_00":0x8000,
    "0F_09":0xF000,
    "10_00":0x8000,
    "10_01":0x9000,
    "10_02":0xF000,
    "10_03":0xF000,
    "10_04":0xF000,
    "10_05":0xF000,
    "10_06":0xF000,
    "10_07":0xF000
    }

for b in bins:
    f = b[0:5]
    m = f + ".s"
    if (m in mods):
        o = m[0:5]+".o"
        modca.append("cc65\\bin\\ca65 mod_bin\\"+m+" -o temp\\"+o)
        ld = "cc65\\bin\\ld65" + \
             (" -o temp\%02X.bin" % count) + \
             (" -C %04X.cfg" % modloc[f]) + \
             " temp\\" + o + \
             " temp\\ramcode.o"
        if (modloc[f] == 0xF000):
            ld = ld + " temp\\vectors.o"
        modld.append(ld)
    else:
        binlist.append("copy src_bin\\"+b+" temp\%02X.bin" % count)
    count += 1

for i in range(count,0xFA):
    binlist.append("copy empty.bin temp\%02X.bin" % i)

print("REM auto generated by binlist.py")
print("")
print("REM build modified banks")
for m in modca:
    print(m)
for m in modld:
    print(m)
print("pause")
print("")
print("REM copy unmodified banks")
for b in binlist:
    print(b)
print("pause")
print("")
print("REM end of auto generated stuff")
